from .download import download_zip, download_file
from pathlib import Path
down_path = Path(__file__).parent
xz_url = "addons_file"+"/"+down_path.name+"/"
download_zip(xz_url + "decaltemplates.zip",down_path)
download_zip(xz_url + "Master.zip",down_path)


bl_info = {
    'name': 'KIT OPS',
    'author': 'Chipp Walters, MX2, proxe, bonjorno7, Mark Kingsnorth',
    'version': (3, 0, 22),
    'blender': (3, 0, 0),
    'location': 'View3D > Toolshelf (T)',
    'description': 'Streamlined kit bash library with additional productivity tools',
    'wiki_url': 'http://cw1.me/kitops3',
    "doc_url": "http://cw1.me/kitops3",
    'category': '3D View'}

from . addon.utility import handler, previews
from . addon.interface import operator, panel
from . addon import preference, property

def register():

    previews.register()
    preference.register()
    property.register()
    operator.register()
    panel.register()
    handler.register()


def unregister():

    handler.unregister()

    panel.unregister()
    operator.unregister()

    property.unregister()
    preference.unregister()

    previews.unregister()
 